const fs = require('fs');

module.exports = (file, api, { transPath, importSource, useInsert }) => {
  const j = api.jscodeshift;
  const root = j(file.source);

  const imports = root.find(j.ImportDeclaration);
  const n = imports.length;

  importSource.forEach((source) => {
    if (n) {
      j(imports.at(0).get()).insertBefore(source); // before the imports
    //  j(imports.at(-1).get()).insertAfter(importSource); // after the imports
    } else {
      root.get().node.program.body.unshift(source); // begining of file
    }
  });

  const appRoots = root.find(j.CallExpression, (node) => {
    if (j.Identifier.check(node.callee) && node.callee.name === 'createApp') {
      return true;
    }

    if (
      j.MemberExpression.check(node.callee)
      && j.Identifier.check(node.callee.object)
      && node.callee.object.name === 'Vue'
      && j.Identifier.check(node.callee.property)
      && node.callee.property.name === 'createApp'
    ) {
      return true;
    }
    return false;
  });

  useInsert.forEach((insert) => {
    appRoots.replaceWith(({ node: createAppCall }) => j.callExpression(
      j.memberExpression(createAppCall, j.identifier('use')),
      [j.identifier(insert)],
    ));
  });

  fs.writeFileSync(transPath, root.toSource());
};
