import ora from 'ora';
import chalk from 'chalk';

class Spinner {
  #spinner = ora();

  #startFlag = false;

  installSpinner = (buffer) => {
    const text = buffer.toString();
    if (text[0] !== '[' && text[text.length - 1] !== '.') return;
    if (this.#startFlag === false) {
      this.#spinner.start(chalk.whiteBright(text));
      this.#startFlag = true;
    } else {
      this.#spinner.succeed();
      this.#spinner.start(chalk.whiteBright(text));
    }
  };

  finishSpinner() {
    this.#spinner.succeed();
  }
}

export default new Spinner();
